> For the complete documentation index, see [llms.txt](https://docs.flatredball.com/flatredball/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flatredball.com/flatredball/glue-reference/enable-live-edit/render-targets.md).

# Render Targets

* Your game may not occup the entire screen
* Interacting with objects in your game may not align properly

You can solve this by disabling render targets in your game. For example, your draw code may look something like this:

```csharp
// make the engine draw to the buffer
GraphicsDevice.SetRenderTarget(buffer);

GeneratedDrawEarly(gameTime);
FlatRedBallServices.Draw();
GeneratedDraw(gameTime);

// reset the render target to null
GraphicsDevice.SetRenderTarget(null);

// draw the buffer to the screen
spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend);
var destinationRectangle = new Rectangle(0, 0, buffer.Width, buffer.Height);
spriteBatch.Draw(buffer, destinationRectangle, Color.White);
spriteBatch.End();

base.Draw(gameTime);
```

You can optionally render to a render target if not in edit mode. For example, after you change your code it might look like this:

```csharp
if(!ScreenManager.IsInEditMode)
{
    // make the engine draw to the buffer
    GraphicsDevice.SetRenderTarget(buffer);
}

GeneratedDrawEarly(gameTime);
FlatRedBallServices.Draw();
GeneratedDraw(gameTime);

if(!ScreenManager.IsInEditMode)
{
    // reset the render target to null
    GraphicsDevice.SetRenderTarget(null);

    // draw the buffer to the screen
    spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend);
    //spriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend, effect: activeEffect);
    var destinationRectangle = new Rectangle(0, 0, buffer.Width, buffer.Height);
    spriteBatch.Draw(buffer, destinationRectangle, Color.White);
    spriteBatch.End();
}

base.Draw(gameTime);
```

Note that future versions of FlatRedBall may provide options for handling render target scaling with the cursor, but as of the time of this writing this is not yet supported.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.flatredball.com/flatredball/glue-reference/enable-live-edit/render-targets.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
